from lib.skn_anm import *
from lib.gbs import *


def read_skn(filepath) -> AnmSkin:
    with open(filepath, "rb") as fp:
        init_filetrack(os.fstat(fp.fileno()).st_size)
        r = AnmFile.parse(fp, AnmSkin)
        print("Read %s%% of file" % stat_track())
        return r


def test():
    f = ["/home/tasty/Projects/gck-map-extract-objects/anm_skn/Verm_l0.skn"]
    my_vertex = Vec3(-0.927200, 0.099500, 3.108000)
    mini_dist_v = Vec3(0, 0, 0)
    for p in f:
        skn = read_skn(p)
        pprint(skn.default_obj_dictionnary)
        pprint(skn.node_dictionnary)
        for obj_name, obj in skn.default_obj_dictionnary.items():
            for cluster in obj.clusters:
                for vertex in cluster.vertices:
                    if vertex.distance(my_vertex) < mini_dist_v.distance(my_vertex):
                        mini_dist_v = vertex

    print("%s: dist=%s" % (mini_dist_v, mini_dist_v.distance(my_vertex)))


def print_vertices():
    skn = read_skn("/home/tasty/Projects/gck-map-extract-objects/test/rp_l0.apatch.gzp.skn")
    for obj_name in skn.default_obj_dictionnary:
        obj = skn.default_obj_dictionnary[obj_name]
        for cluster in obj.clusters:
            for vertex in cluster.vertices:
                print("v %s %s %s" % (vertex.x, vertex.y, vertex.z))


def link_gbs_skn():
    basepath = "/home/tasty/Projects/gck-map-extract-objects/test/rp_l0.apatch.gzp"
    skn = read_skn(basepath+".skn")
    gbs = GbsData()
    gbs.read(basepath+".gbs")

    vbase = 0
    with open("test.obj", "w") as fp:
        for obj_name, obj in skn.default_obj_dictionnary.items():
            for cluster in obj.clusters:
                for vertex in cluster.vertices:
                    base_vertex_i = vertex.index + vbase
                    base_vertex = gbs.vertices[base_vertex_i]
                    new_vertex = Vec3(base_vertex.x + vertex.x, base_vertex.y + vertex.y, base_vertex.z + vertex.z)
                    fp.write("v %s %s %s\n" % (new_vertex.x, new_vertex.y, new_vertex.z))
            vbase += obj.total_number_vertices


def main():
    skn = read_skn("/home/tasty/Projects/gck-map-extract-objects/test/rp_l0.apatch.gzp.skn")
    pprint(skn)
    vbase = 0
    for tree in skn.tree_dictionnary:
        for obj_name in skn.tree_dictionnary[tree]:
            print(obj_name)
            obj = skn.tree_dictionnary[tree][obj_name]
            for cluster in obj.clusters:
                if cluster.num_vertices <= 0:
                    print("NO VERTICES")
                for vertex in cluster.vertices:
                    pass
                    # print("vertex %s -> %s" % (vertex.index, vertex.index + vbase))
            vbase += obj.total_number_vertices

    with open("test.obj", "w") as fp:
        vbase = 0
        for obj_name, obj in skn.default_obj_dictionnary.items():
            for cluster in obj.clusters:
                # fp.write("name %s %s %s %s %s %s %s\n" % (cluster.bone_name.strip().replace(" ", ""), cluster.bounding_box[0].x, cluster.bounding_box[0].y, cluster.bounding_box[0].z, cluster.bounding_box[1].x, cluster.bounding_box[1].y, cluster.bounding_box[1].z))
                for vertex in cluster.vertices:
                    fp.write("index %s\n" % (vertex.index + vbase))
                    # fp.write("offset %s %s %s\n" % (vertex.x, vertex.y, vertex.z))
            vbase += obj.total_number_vertices


if __name__ == "__main__":
    main()
